#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <shout/shout.h>

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(char *name, int arg)
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	// SHOUTERR_INSANE
	if (strEQ(name, "SHOUTERR_INSANE"))
#ifdef SHOUTERR_INSANE
	    return SHOUTERR_INSANE;
#else
	    goto not_there;
#endif
	// SHOUTERR_NOCONNECT
	if (strEQ(name, "SHOUTERR_NOCONNECT"))
#ifdef SHOUTERR_NOCONNECT
	    return SHOUTERR_NOCONNECT;
#else
	    goto not_there;
#endif
	// SHOUTERR_NOLOGIN
	if (strEQ(name, "SHOUTERR_NOLOGIN"))
#ifdef SHOUTERR_NOLOGIN
	    return SHOUTERR_NOLOGIN;
#else
	    goto not_there;
#endif
	// SHOUTERR_SOCKET
	if (strEQ(name, "SHOUTERR_SOCKET"))
#ifdef SHOUTERR_SOCKET
	    return SHOUTERR_SOCKET;
#else
	    goto not_there;
#endif
	// SHOUTERR_MALLOC
	if (strEQ(name, "SHOUTERR_MALLOC"))
#ifdef SHOUTERR_MALLOC
	    return SHOUTERR_MALLOC;
#else
	    goto not_there;
#endif
	// SHOUTERR_METADATA
	if (strEQ(name, "SHOUTERR_METADATA"))
#ifdef SHOUTERR_METADATA
	    return SHOUTERR_METADATA;
#else
	    goto not_there;
#endif
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


MODULE = Shout		PACKAGE = Shout		

PROTOTYPES: ENABLE

double
constant(name,arg)
	char *		name
	int		arg

shout_conn_t *
raw_new(CLASS)
	char *CLASS
	CODE:
	RETVAL = (shout_conn_t *)safemalloc(sizeof(shout_conn_t));
	if (RETVAL == NULL) {
		warn("unable to allocate shout_conn_t");
		XSRETURN_UNDEF;
	}
	OUTPUT:
	RETVAL

void
DESTROY(self)
	shout_conn_t *self
	CODE:
	safefree(self->ip);
	safefree(self->mount);
	safefree(self->password);
	safefree(self->dumpfile);
	safefree(self->name);
	safefree(self->genre);
	safefree(self->url);
	safefree(self->description);
	safefree((char *)self);

void
shout_set_ip(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->ip = strdup(str);

void
shout_set_port(self, num)
	shout_conn_t *self
	int num
	CODE:
	self->port = num;

void
shout_set_mount(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->mount = strdup(str);

void
shout_set_password(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->password = strdup(str);

void
shout_set_icy_compat(self, num)
	shout_conn_t *self
	int num
	CODE:
	self->icy_compat = num;

void
shout_set_dumpfile(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->dumpfile = strdup(str);

void
shout_set_name(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->name = strdup(str);

void
shout_set_url(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->url = strdup(str);

void
shout_set_genre(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->genre = strdup(str);

void
shout_set_description(self, str)
	shout_conn_t *self
	char *str
	CODE:
	self->description = strdup(str);

void
shout_set_bitrate(self, num)
	shout_conn_t *self
	int num
	CODE:
	self->bitrate = num;

void
shout_set_ispublic(self, num)
	shout_conn_t *self
	int num
	CODE:
	self->ispublic = num;

char *
shout_get_ip(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->ip;
	OUTPUT:
	RETVAL

int
shout_get_port(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->port;
	OUTPUT:
	RETVAL

char *
shout_get_mount(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->mount;
	OUTPUT:
	RETVAL

char *
shout_get_password(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->password;
	OUTPUT:
	RETVAL

int
shout_get_icy_compat(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->icy_compat;
	OUTPUT:
	RETVAL

char *
shout_get_dumpfile(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->dumpfile;
	OUTPUT:
	RETVAL

char *
shout_get_name(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->name;
	OUTPUT:
	RETVAL

char *
shout_get_url(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->url;
	OUTPUT:
	RETVAL

char *
shout_get_genre(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->genre;
	OUTPUT:
	RETVAL

char *
shout_get_description(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->description;
	OUTPUT:
	RETVAL

int
shout_get_bitrate(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->bitrate;
	OUTPUT:
	RETVAL

int
shout_get_ispublic(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->ispublic;
	OUTPUT:
	RETVAL

int
shout_error(self)
	shout_conn_t *self
	CODE:
	RETVAL = self->error;
	OUTPUT:
	RETVAL

void
shout_init_connection(self)
	shout_conn_t *self

int
shout_connect(self)
	shout_conn_t *self

int
shout_disconnect(self)
	shout_conn_t *self

int
shout_send_data(self, buff, len)
        shout_conn_t *self
        unsigned char *buff
        unsigned long len

void
shout_sleep(self)
        shout_conn_t *self

int
shout_update_metadata(self, metadata)
        shout_conn_t *self
        char *metadata
